// DMMSataSelfTest.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <conio.h>
#include <ctype.h>

#include "DMMSataSelfTest.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

int loop;
char Args[256];
int ha, tid, lun;
char *p;
BYTE Cmd[16];
int BufSize = 512;
int DataDir = 1;
CString strInfo;
DWORD dwLastError;
CString strMMFName;
CString m_strDMMText;
int MyStrLength;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
		// here's the meat of the program...
		//

		for (loop = 0; loop < argc; loop++) // get the command line arguements for ha, target, & lun
		{
			sprintf(Args,"%s\n",argv[loop]);
			if ( strstr(Args,"HBA") != NULL) {
				p = Args;
				p = strtok( Args, "," );
				p+=4;
				sscanf(p,"%d",&ha);

				p = strtok(NULL,",");
				p+=4;
				sscanf(p,"%d",&tid);

				p = strtok(NULL,",");
				p+=4;
				sscanf(p,"%d",&lun);
				break;
			}
		} // end of parsing command line args

	// send a self-test command, wait 2 minutes so it should be done
	// we are using SAT to send the ATA command to a SATA drive connected to a SAS SAT-Compliant HBA
		Cmd[0] = 0xA1;
		Cmd[1] = 0x06;
		Cmd[2] = 0x00;
		Cmd[3] = 0xD4;
		Cmd[4] = 0x00;
		Cmd[5] = 0x01;
		Cmd[6] = 0x4F;
		Cmd[7] = 0xC2;
		Cmd[8] = 0x00;
		Cmd[9] = 0xB0;
		Cmd[10] = 0x00;
		Cmd[11] = 0x00;
		Cmd[12] = 0x00;
		Cmd[13] = 0x00;
		Cmd[14] = 0x00;
		Cmd[15] = 0x00;
		BufSize = 0;
	
	// use DTB SCSI User Defined CDB to send the command to the drive
		nRetCode = VCSCSIUserCdbTimeout(ha,
			tid,
			lun,
			&Cmd[0], 
			12, 
			DataDir,
			BufSize, 
			0, 
			15
			);

		if (nRetCode != 1) // DTB will return 1 on success - so fail this test if it isn't 1
			return 1;

		nRetCode = 0; // make sure we pass back "success" to DMM


		Sleep(120000); // wait two minutes for the self test to finish
	// you could keep sending SMART DATA commands and watch the status to see when the self test is done, but
	// for a short self test its not worth the bother.

		m_strDMMText = "\nExecuted SMART Short Self-Test - Immediate Offline mode\n"; 
		// put something in the string to send back to DMM for logging...

	// the following lines do what is needed to send info back to the DMM log file
		// the file name is important - you need to specify which devices log file this info will go to
		//
		strMMFName.Format("DMM_HBA%02dTID%03dLUN%02d",ha,tid,lun);
		HANDLE hMMF = OpenFileMapping(FILE_MAP_ALL_ACCESS,
                              FALSE,
                              strMMFName);
		if (!hMMF)
		{
			dwLastError = GetLastError();
			hMMF = CreateFileMapping((HANDLE)INVALID_HANDLE_VALUE,
                            NULL,PAGE_READWRITE,
                            0,
                            0x1000,
                            strMMFName);
		}
		if (hMMF)
		{
			char * pBlah = (char *)MapViewOfFile(hMMF,
                                      FILE_MAP_ALL_ACCESS,
                                      0,
                                      0,
                                      0x1000);
			// we can only send a max of 4096 bytes via this method - so make sure we don't try to send more
			MyStrLength = strlen(m_strDMMText);
			if (MyStrLength > 4096)
				MyStrLength = 4096;
			int * pIntPtr = (int *)pBlah;
			*pIntPtr = 1;
			strcpy(&pBlah[4],m_strDMMText);
			FlushViewOfFile(pBlah,MyStrLength);
			UnmapViewOfFile(pBlah);
			CloseHandle(hMMF);
		}
		else
			dwLastError = GetLastError();

	} // end of mfc initiallizing OK
	return nRetCode;
} // end of main



